// TestControlCtrl.cpp : Implementation of the CTestControlCtrl ActiveX Control class.

#include "stdafx.h"
#include "TestControl.h"
#include "TestControlCtrl.h"
#include "TestControlPropPage.h"
#include ".\testcontrolctrl.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#endif


IMPLEMENT_DYNCREATE(CTestControlCtrl, COleControl)



// Message map

BEGIN_MESSAGE_MAP(CTestControlCtrl, COleControl)
	ON_OLEVERB(AFX_IDS_VERB_PROPERTIES, OnProperties)
END_MESSAGE_MAP()



// Dispatch map

BEGIN_DISPATCH_MAP(CTestControlCtrl, COleControl)
	DISP_FUNCTION_ID(CTestControlCtrl, "AboutBox", DISPID_ABOUTBOX, AboutBox, VT_EMPTY, VTS_NONE)
	DISP_FUNCTION(CTestControlCtrl, "TestCall", TestCall, VT_I2, VTS_NONE)
END_DISPATCH_MAP()



// Event map

BEGIN_EVENT_MAP(CTestControlCtrl, COleControl)
END_EVENT_MAP()



// Property pages

// TODO: Add more property pages as needed.  Remember to increase the count!
BEGIN_PROPPAGEIDS(CTestControlCtrl, 1)
	PROPPAGEID(CTestControlPropPage::guid)
END_PROPPAGEIDS(CTestControlCtrl)



// Initialize class factory and guid

IMPLEMENT_OLECREATE_EX(CTestControlCtrl, "TESTCONTRO.TestControCtrl.1",
	0x6f2e761f, 0x4462, 0x4d4b, 0x80, 0xcd, 0xe7, 0xd9, 0x26, 0x8d, 0xc4, 0xdf)



// Type library ID and version

IMPLEMENT_OLETYPELIB(CTestControlCtrl, _tlid, _wVerMajor, _wVerMinor)



// Interface IDs

const IID BASED_CODE IID_DTestControl =
		{ 0xE8A6BFC3, 0x87DB, 0x48DF, { 0x81, 0x2A, 0x2E, 0x79, 0x60, 0x4C, 0x1A, 0xA3 } };
const IID BASED_CODE IID_DTestControlEvents =
		{ 0xBAC9A40A, 0x4534, 0x4BA9, { 0x9E, 0xB3, 0xC9, 0x5A, 0x4F, 0xFE, 0x4F, 0x42 } };



// Control type information

static const DWORD BASED_CODE _dwTestControlOleMisc =
	OLEMISC_ACTIVATEWHENVISIBLE |
	OLEMISC_SETCLIENTSITEFIRST |
	OLEMISC_INSIDEOUT |
	OLEMISC_CANTLINKINSIDE |
	OLEMISC_RECOMPOSEONRESIZE;

IMPLEMENT_OLECTLTYPE(CTestControlCtrl, IDS_TESTCONTROL, _dwTestControlOleMisc)



// CTestControlCtrl::CTestControlCtrlFactory::UpdateRegistry -
// Adds or removes system registry entries for CTestControlCtrl

BOOL CTestControlCtrl::CTestControlCtrlFactory::UpdateRegistry(BOOL bRegister)
{
	// TODO: Verify that your control follows apartment-model threading rules.
	// Refer to MFC TechNote 64 for more information.
	// If your control does not conform to the apartment-model rules, then
	// you must modify the code below, changing the 6th parameter from
	// afxRegApartmentThreading to 0.

	if (bRegister)
		return AfxOleRegisterControlClass(
			AfxGetInstanceHandle(),
			m_clsid,
			m_lpszProgID,
			IDS_TESTCONTROL,
			IDB_TESTCONTROL,
			afxRegApartmentThreading,
			_dwTestControlOleMisc,
			_tlid,
			_wVerMajor,
			_wVerMinor);
	else
		return AfxOleUnregisterClass(m_clsid, m_lpszProgID);
}



// CTestControlCtrl::CTestControlCtrl - Constructor

CTestControlCtrl::CTestControlCtrl()
{
	InitializeIIDs(&IID_DTestControl, &IID_DTestControlEvents);
	// TODO: Initialize your control's instance data here.
}



// CTestControlCtrl::~CTestControlCtrl - Destructor

CTestControlCtrl::~CTestControlCtrl()
{
	// TODO: Cleanup your control's instance data here.
}



// CTestControlCtrl::OnDraw - Drawing function

void CTestControlCtrl::OnDraw(
			CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid)
{
	if (!pdc)
		return;

	// TODO: Replace the following code with your own drawing code.
	pdc->FillRect(rcBounds, CBrush::FromHandle((HBRUSH)GetStockObject(WHITE_BRUSH)));
	pdc->Ellipse(rcBounds);
}



// CTestControlCtrl::DoPropExchange - Persistence support

void CTestControlCtrl::DoPropExchange(CPropExchange* pPX)
{
	ExchangeVersion(pPX, MAKELONG(_wVerMinor, _wVerMajor));
	COleControl::DoPropExchange(pPX);

	// TODO: Call PX_ functions for each persistent custom property.
}



// CTestControlCtrl::OnResetState - Reset control to default state

void CTestControlCtrl::OnResetState()
{
	COleControl::OnResetState();  // Resets defaults found in DoPropExchange

	// TODO: Reset any other control state here.
}



// CTestControlCtrl::AboutBox - Display an "About" box to the user

void CTestControlCtrl::AboutBox()
{
	CDialog dlgAbout(IDD_ABOUTBOX_TESTCONTROL);
	dlgAbout.DoModal();
}



// CTestControlCtrl message handlers

short CTestControlCtrl::TestCall( void )
{
	return 0; // do nothing since we want to measure overhead
}
